=begin
(c) TIG 2012
Permission to use, copy, modify, and distribute this software for 
any purpose and without fee is hereby granted, provided that the above
copyright notice appear in all copies.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
  TIG-groups2components.rb
Usage: Preselect the 'equivalent' groups to convert.
Type [copy/paste] this into the Ruby Console
  TIG.groups2components
This takes the selection of groups and turns them all into 
instances of one component that is made from the first group in the 
selection.  The insertion points of the selected groups is rationalized 
so that groups that are effectively the same form [e.g. rafters made 
using 1001-tools] but with varying insertion points are accommodated. 
Only use it on groups that are either copies of the same group, or 
groups that are 'equivalent' in 'form' to each other, because it will 
affect all groups selected.  Each group's layer and material is 
duplicated in the new instance that replaces it.
It is one step undoable in case of disasters !
Donations: Paypal.com = info @ revitrev . org
Version: 1.0 20120208 First proper release.
=end
require 'sketchup.rb'
module TIG
def self.groups2components
  model=Sketchup.active_model
  ents=model.active_entities
  ss=model.selection
  gps=[]
  ss.each{|e|gps << e if e.class==Sketchup::Group}
 model.start_operation('TIG.groups2components')
  gps.each{|gp|
	df=gp.entities.parent
	df.invalidate_bounds
	og=gp.transformation.origin
	tr=Geom::Transformation.new()
	temp=ents.add_instance(df, tr)
	bb=Geom::BoundingBox.new
	df.entities.each{|e|
	  if e.class==Sketchup::Edge
	    bb.add(e.start.position)
		bb.add(e.end.position)
	  end
	}
	bbmin=bb.min
	vv=bbmin.vector_to(ORIGIN)
	tr=Geom::Transformation.translation(vv)
	df.entities.transform_entities(tr, df.entities.to_a)
	df.invalidate_bounds
	temp.erase!
	ve=og.vector_to(bbmin.transform(gp.transformation))
	tr=Geom::Transformation.translation(ve)
	gp.transform!(tr)
  }### now we process the groups
  inst=gps[0].to_component
  defn=inst.definition
  gps[1..-1].each{|gp|
    next unless gp.valid?
    tr=gp.transformation
	la=gp.layer
	ma=gp.material
	gp.erase!
	inst=ents.add_instance(defn, tr)
	inst.layer=la
	inst.material=ma
  }
  ss.clear
  ss.add(defn.instances)
 model.commit_operation
end#def
end#module
